'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GifPanelGrid = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * A table that updates with image
 * data
 *
 * @class ResolutionTable
 * @extends React.Component
 */
var GifPanelGrid = exports.GifPanelGrid = function (_React$Component) {
  _inherits(GifPanelGrid, _React$Component);

  function GifPanelGrid() {
    _classCallCheck(this, GifPanelGrid);

    return _possibleConstructorReturn(this, (GifPanelGrid.__proto__ || Object.getPrototypeOf(GifPanelGrid)).apply(this, arguments));
  }

  _createClass(GifPanelGrid, [{
    key: 'renderImageSize',
    value: function renderImageSize() {
      var size = this.props.requestSize;
      if (!this.props.valid) {
        return _react2.default.createElement(
          'div',
          { id: 'gif-size', className: 'gif-size gif-size-invalid grid-child' },
          _react2.default.createElement('i', { className: 'fa fa-times fa-fw' }),
          _react2.default.createElement(
            'span',
            null,
            '~' + size + ' MB (Before Compression)'
          )
        );
      } else {
        return _react2.default.createElement(
          'div',
          { id: 'gif-size', className: 'gif-size grid-child' },
          _react2.default.createElement(
            'span',
            null,
            '~' + size + ' MB (Before Compression)',
            ' '
          )
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var imageSize = this.renderImageSize();
      return _react2.default.createElement(
        'div',
        { className: 'gif-download-grid' },
        _react2.default.createElement(
          'div',
          { className: 'grid-child label' },
          _react2.default.createElement(
            'span',
            null,
            'Start Date: '
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child' },
          _react2.default.createElement(
            'span',
            null,
            this.props.startDate,
            ' '
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child label' },
          _react2.default.createElement(
            'span',
            null,
            'End Date: '
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child' },
          _react2.default.createElement(
            'span',
            null,
            this.props.endDate
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child label' },
          _react2.default.createElement(
            'span',
            null,
            'Speed: '
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child' },
          _react2.default.createElement(
            'span',
            null,
            this.props.speed + ' Frames Per Second'
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child label' },
          _react2.default.createElement(
            'span',
            null,
            'Increment:'
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child' },
          _react2.default.createElement(
            'span',
            null,
            this.props.increment
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child label' },
          _react2.default.createElement(
            'span',
            null,
            'Request Size:'
          )
        ),
        imageSize,
        _react2.default.createElement(
          'div',
          { className: 'grid-child label' },
          _react2.default.createElement(
            'span',
            null,
            'Max Request Size: '
          )
        ),
        _react2.default.createElement(
          'div',
          { className: this.props.valid ? 'grid-child gif-max-size' : 'grid-child gif-max-size gif-size-invalid' },
          _react2.default.createElement(
            'span',
            null,
            this.props.maxGifSize + ' MB (Before Compression)'
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child label' },
          _react2.default.createElement(
            'span',
            null,
            'Image Dimensions:'
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child', id: 'wv-image-width' },
          _react2.default.createElement(
            'span',
            null,
            this.props.width + ' x ' + this.props.height + 'px'
          )
        )
      );
    }
  }]);

  return GifPanelGrid;
}(_react2.default.Component);

GifPanelGrid.propTypes = {
  width: _propTypes2.default.number,
  height: _propTypes2.default.number,
  maxGifSize: _propTypes2.default.number,
  startDate: _propTypes2.default.string,
  endDate: _propTypes2.default.string,
  speed: _propTypes2.default.number,
  valid: _propTypes2.default.bool,
  requestSize: _propTypes2.default.number,
  fileSizeEstimate: _propTypes2.default.number,
  increment: _propTypes2.default.string
};