'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _selector = require('../util/selector');

var _selector2 = _interopRequireDefault(_selector);

var _gifPanelGrid = require('./gif-panel-grid');

var _button = require('../util/button');

var _button2 = _interopRequireDefault(_button);

var _checkbox = require('../util/checkbox');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * A react component, Builds a rather specific
 * interactive widget
 *
 * @class resolutionSelection
 * @extends React.Component
 */
var GifPanel = function (_React$Component) {
  _inherits(GifPanel, _React$Component);

  function GifPanel(props) {
    _classCallCheck(this, GifPanel);

    var _this = _possibleConstructorReturn(this, (GifPanel.__proto__ || Object.getPrototypeOf(GifPanel)).call(this, props));

    _this.state = {
      imgHeight: props.imgHeight,
      imgWidth: props.imgWidth,
      speed: props.speed,
      resolutions: props.resolutions,
      onSelectionChange: props.onSelectionChange,
      resolution: props.resolution,
      valid: props.valid,
      showDates: props.showDates,
      increment: props.increment
    };
    return _this;
  }

  _createClass(GifPanel, [{
    key: 'handleChange',
    value: function handleChange(type, value) {
      this.setState({
        resolution: value
      });
      this.props.onSelectionChange(value);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'animation-gif-dialog-wrapper' },
        _react2.default.createElement(
          'div',
          { className: 'gif-selector-case' },
          this.props.firstLabel,
          _react2.default.createElement(_selector2.default, {
            id: 'gif-resolution',
            optionArray: this.state.resolutions,
            value: this.state.resolution,
            optionName: 'resolution',
            onChange: this.handleChange.bind(this)
          })
        ),
        _react2.default.createElement(_gifPanelGrid.GifPanelGrid, {
          width: this.state.imgWidth,
          height: this.state.imgHeight,
          requestSize: this.state.requestSize,
          maxGifSize: this.props.maxGifSize,
          valid: this.state.valid,
          onClick: this.props.onDownloadClick,
          startDate: this.state.startDate,
          endDate: this.state.endDate,
          speed: this.state.speed,
          increment: this.state.increment
        }),
        _react2.default.createElement(_button2.default, {
          onClick: this.props.onClick,
          text: 'Create GIF',
          valid: this.state.valid
        }),
        _react2.default.createElement(_checkbox.Checkbox, {
          id: 'wv-checkbox-gif',
          classNames: 'wv-checkbox-gif',
          title: 'Check box to remove dates from Animating GIF',
          checked: this.props.checked,
          onCheck: this.props.onCheck,
          label: 'Include Date Stamps'
        })
      );
    }
  }]);

  return GifPanel;
}(_react2.default.Component);

exports.default = GifPanel;


GifPanel.defaultProps = {
  firstLabel: 'Resolution (per pixel):',
  secondLabel: 'Format',
  maxGifSize: 20,
  showDates: true
};
GifPanel.propTypes = {
  firstLabel: _propTypes2.default.string,
  secondLabel: _propTypes2.default.string,
  imgWidth: _propTypes2.default.number,
  imgHeight: _propTypes2.default.number,
  maxGifSize: _propTypes2.default.number,
  showDates: _propTypes2.default.bool,
  onDownloadClick: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  onCheck: _propTypes2.default.func,
  checked: _propTypes2.default.bool,
  onSelectionChange: _propTypes2.default.func,
  resolutions: _propTypes2.default.object,
  requestSize: _propTypes2.default.string,
  resolution: _propTypes2.default.string,
  speed: _propTypes2.default.number,
  valid: _propTypes2.default.bool,
  increment: _propTypes2.default.string
};