'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _input = require('./input');

var _input2 = _interopRequireDefault(_input);

var _util = require('../util/util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var util = new _util2.default();

/*
 * A react component, is a draggable svg
 * group. It is a parent component that
 * rerenders when child elements are dragged
 *
 * @class TimelineRangeSelector
 */

var dateSelector = function (_React$Component) {
  _inherits(dateSelector, _React$Component);

  /*
   * @constructor
   */
  function dateSelector(props) {
    _classCallCheck(this, dateSelector);

    var _this = _possibleConstructorReturn(this, (dateSelector.__proto__ || Object.getPrototypeOf(dateSelector)).call(this, props));

    _this.state = {
      date: props.date,
      maxDate: props.maxDate,
      minDate: props.minDate,
      tab: null,
      maxZoom: props.maxZoom
    };
    return _this;
  }

  _createClass(dateSelector, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      this.setState({
        date: props.date,
        maxDate: props.maxDate,
        minDate: props.minDate,
        maxZoom: props.maxZoom
      });
    }
  }, {
    key: 'blur',
    value: function blur() {
      this.setState({ tab: null });
    }
  }, {
    key: 'nextTab',
    value: function nextTab(index) {
      var nextTab;
      var maxTab;
      if (this.state.maxZoom >= 4) {
        maxTab = 5;
      } else {
        maxTab = 3;
      }
      if (index < maxTab) {
        nextTab = index + 1;
      } else {
        nextTab = 1;
      }
      this.setState({
        tab: nextTab
      });
    }
  }, {
    key: 'updateDate',
    value: function updateDate(date) {
      this.setState({
        date: date
      });
      this.props.onDateChange(this.props.id, date);
    }
  }, {
    key: 'renderSubdaily',
    value: function renderSubdaily() {
      if (this.state.maxZoom >= 4) {
        return _react2.default.createElement(
          _react2.default.Fragment,
          null,
          _react2.default.createElement(_input2.default, {
            step: 1,
            startDate: new Date(2000),
            today: new Date(),
            date: this.state.date,
            type: 'hour',
            inputId: this.props.idSuffix ? 'hour-' + this.props.idSuffix : '',
            height: this.props.height,
            width: this.props.width,
            updateDate: this.updateDate.bind(this),
            value: util.pad(this.state.date.getUTCHours(), 2, '0'),
            tabIndex: 4,
            focused: this.state.tab === 4,
            nextTab: this.nextTab.bind(this),
            maxDate: this.props.maxDate,
            minDate: this.props.minDate,
            blur: this.blur.bind(this)
          }),
          _react2.default.createElement(
            'div',
            { className: 'input-time-divider' },
            ':'
          ),
          _react2.default.createElement(_input2.default, {
            step: 10,
            startDate: new Date(2000),
            today: new Date(),
            date: this.state.date,
            type: 'minute',
            height: this.props.height,
            width: this.props.width,
            updateDate: this.updateDate.bind(this),
            value: util.pad(this.state.date.getUTCMinutes(), 2, '0'),
            inputId: this.props.idSuffix ? 'minute-' + this.props.idSuffix : '',
            tabIndex: 5,
            focused: this.state.tab === 5,
            nextTab: this.nextTab.bind(this),
            maxDate: this.props.maxDate,
            minDate: this.props.minDate,
            blur: this.blur.bind(this)
          }),
          _react2.default.createElement(
            'div',
            { className: 'input-time-zmark' },
            'Z'
          )
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'wv-date-selector-widget' },
        _react2.default.createElement(_input2.default, {
          step: 1,
          startDate: new Date(2000),
          today: new Date(),
          date: this.state.date,
          value: this.state.date.getUTCFullYear(),
          type: 'year',
          height: this.props.height,
          width: this.props.width,
          updateDate: this.updateDate.bind(this),
          inputId: this.props.idSuffix ? 'year-' + this.props.idSuffix : '',
          tabIndex: 1,
          focused: this.state.tab === 1,
          nextTab: this.nextTab.bind(this),
          maxDate: this.props.maxDate,
          minDate: this.props.minDate,
          blur: this.blur.bind(this) }),
        _react2.default.createElement(_input2.default, {
          step: 1,
          startDate: new Date(2000),
          today: new Date(),
          date: this.state.date,
          value: util.monthStringArray[this.state.date.getUTCMonth()],
          type: 'month',
          inputId: this.props.idSuffix ? 'month-' + this.props.idSuffix : '',
          height: this.props.height,
          width: this.props.width,
          updateDate: this.updateDate.bind(this),
          tabIndex: 2,
          focused: this.state.tab === 2,
          nextTab: this.nextTab.bind(this),
          maxDate: this.props.maxDate,
          minDate: this.props.minDate,
          blur: this.blur.bind(this)
        }),
        _react2.default.createElement(_input2.default, {
          step: 1,
          startDate: new Date(2000),
          today: new Date(),
          date: this.state.date,
          type: 'day',
          height: this.props.height,
          width: this.props.width,
          updateDate: this.updateDate.bind(this),
          value: util.pad(this.state.date.getUTCDate(), 2, '0'),
          tabIndex: 3,
          inputId: this.props.idSuffix ? 'day-' + this.props.idSuffix : '',
          focused: this.state.tab === 3,
          nextTab: this.nextTab.bind(this),
          maxDate: this.props.maxDate,
          minDate: this.props.minDate,
          blur: this.blur.bind(this)
        }),
        this.renderSubdaily()
      );
    }
  }]);

  return dateSelector;
}(_react2.default.Component);

dateSelector.propTypes = {
  date: _propTypes2.default.object,
  maxDate: _propTypes2.default.object,
  minDate: _propTypes2.default.object,
  maxZoom: _propTypes2.default.number,
  onDateChange: _propTypes2.default.func,
  id: _propTypes2.default.string,
  height: _propTypes2.default.string,
  width: _propTypes2.default.string,
  idSuffix: _propTypes2.default.string
};

exports.default = dateSelector;