'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * A react component, Builds a SVG line who's dimensions and styles
 * are customizable
 *
 * @class Line
 * @extends React.Component
 */
var Line = function (_React$Component) {
  _inherits(Line, _React$Component);

  /*
   * Sets state and extents props
   */
  function Line(props) {
    _classCallCheck(this, Line);

    var _this = _possibleConstructorReturn(this, (Line.__proto__ || Object.getPrototypeOf(Line)).call(this, props));

    _this.state = {
      hovered: false,
      height: props.height,
      active: true
    };
    return _this;
  }

  /*
   * Updates state on svg hover
   *
   * return {Void}
   */


  _createClass(Line, [{
    key: 'mouseOver',
    value: function mouseOver() {
      this.setState({
        hovered: true
      });
    }

    /*
     * Updates state on svg mouseout
     *
     * return {Void}
     */

  }, {
    key: 'mouseOut',
    value: function mouseOut() {
      this.setState({
        hovered: false
      });
    }

    /*
     * Runs lineOver props method when
     * the invisible line is hovered, passing
     * event properties
     *
     * @param {Object} e - React event object
     * return {Void}
     */

  }, {
    key: 'mouseOverHidden',
    value: function mouseOverHidden(e) {
      this.props.lineOver([e.clientX, e.clientY], this.props.overlay, this.props.lineX, this.props.tooltip);
    }

    /*
     * Runs lineOut props method when
     * the invisible line is not longer hovered, passing
     * the react component to deactivate
     *
     * return {Void}
     */

  }, {
    key: 'mouseOutHidden',
    value: function mouseOutHidden() {
      this.props.lineOut(this.props.tooltip);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'svg',
        {
          onMouseOver: this.mouseOver.bind(this),
          onMouseOut: this.mouseOut.bind(this),
          style: this.props.svgStyle,
          width: this.props.width,
          id: this.props.id,
          height: this.state.height,
          className: this.props.classes },
        _react2.default.createElement('line', {
          strokeWidth: this.props.strokeWidth,
          stroke: this.props.color,
          opacity: this.state.hovered && this.state.active ? this.props.opacity : '0',
          x1: this.props.strokeWidth / 2,
          x2: this.props.strokeWidth / 2,
          strokeDasharray: this.props.dashArray,
          y2: this.state.height,
          y1: '0' }),
        _react2.default.createElement('line', { className: 'dateline-hidden',
          onMouseOver: this.mouseOverHidden.bind(this),
          onMouseMove: this.mouseOverHidden.bind(this),
          onMouseOut: this.mouseOutHidden.bind(this),
          style: this.props.style,
          opacity: '0',
          x1: this.props.strokeWidth / 2,
          x2: this.props.strokeWidth / 2,
          strokeWidth: this.props.strokeWidth,
          stroke: this.props.color,
          y1: '0',
          y2: this.state.height })
      );
    }
  }]);

  return Line;
}(_react2.default.Component);

Line.defaultProps = {
  dashArray: '5, 10',
  opacity: '0.5',
  width: '10',
  strokeWidth: '6',
  color: 'white',
  height: 200,
  svgStyle: {
    margin: '0 40px 0 40px',
    transform: 'translateX(-43px)'
  }
};

Line.propTypes = {
  dashArray: _propTypes2.default.string,
  opacity: _propTypes2.default.string,
  width: _propTypes2.default.string,
  strokeWidth: _propTypes2.default.string,
  color: _propTypes2.default.string,
  height: _propTypes2.default.number,
  lineX: _propTypes2.default.number,
  lineOver: _propTypes2.default.func,
  lineOut: _propTypes2.default.func,
  svgStyle: _propTypes2.default.object,
  tooltip: _propTypes2.default.object,
  overlay: _propTypes2.default.object,
  style: _propTypes2.default.object,
  id: _propTypes2.default.string,
  classes: _propTypes2.default.string
};

exports.default = Line;