'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * Builds an SVG text box
 *
 * @class LineText
 * @extends React.Component
 */
var LineText = function (_React$Component) {
  _inherits(LineText, _React$Component);

  /*
   * Sets state and extents props
   */
  function LineText(props) {
    _classCallCheck(this, LineText);

    var _this = _possibleConstructorReturn(this, (LineText.__proto__ || Object.getPrototypeOf(LineText)).call(this, props));

    _this.state = {
      active: false,
      dateRight: props.dateRight,
      dateLeft: props.dateLeft
    };
    return _this;
  }

  _createClass(LineText, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'svg',
        { className: 'dateline-text', style: this.props.svgStyle },
        _react2.default.createElement('rect', {
          fill: this.props.fill,
          width: this.props.textWidth,
          height: this.props.textHeight,
          x: this.props.x1,
          rx: this.props.recRadius,
          opacity: this.state.active ? this.props.rectOpacity : '0' }),
        _react2.default.createElement(
          'text',
          {
            y: this.props.textY,
            x: this.props.x1 + 3,
            fill: this.props.color,
            width: this.props.width,
            opacity: this.state.active ? this.props.textOpacity : '0'
          },
          this.state.dateLeft
        ),
        _react2.default.createElement('rect', {
          fill: this.props.fill,
          width: this.props.textWidth,
          height: this.props.textHeight,
          x: this.props.x2,
          rx: this.props.recRadius,
          opacity: this.state.active ? this.props.rectOpacity : '0'
        }),
        _react2.default.createElement(
          'text',
          {
            y: this.props.textY,
            x: this.props.x2 + 3,
            fill: this.props.color,
            opacity: this.state.active ? this.props.textOpacity : '0'
          },
          this.state.dateRight
        )
      );
    }
  }]);

  return LineText;
}(_react2.default.Component);

LineText.defaultProps = {
  textOpacity: 0.7,
  rectOpacity: 1,
  width: '300',
  color: 'white',
  textY: 14,
  fill: 'rgba(40,40,40,0.5)',
  x2: 155,
  x1: 45,
  textWidth: 80,
  textHeight: 20,
  recRadius: 3,
  svgStyle: {
    transform: 'translateX(-140px)'
  }
};

LineText.propTypes = {
  textOpacity: _propTypes2.default.number,
  rectOpacity: _propTypes2.default.number,
  width: _propTypes2.default.string,
  color: _propTypes2.default.string,
  textY: _propTypes2.default.number,
  fill: _propTypes2.default.string,
  dateLeft: _propTypes2.default.string,
  dateRight: _propTypes2.default.string,
  x2: _propTypes2.default.number,
  x1: _propTypes2.default.number,
  textWidth: _propTypes2.default.number,
  textHeight: _propTypes2.default.number,
  recRadius: _propTypes2.default.number,
  svgStyle: _propTypes2.default.object
};

exports.default = LineText;