'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _button = require('../util/button');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * A table that updates with image
 * data
 *
 * @class ResolutionTable
 * @extends React.Component
 */
var ResolutionTable = function (_React$Component) {
  _inherits(ResolutionTable, _React$Component);

  function ResolutionTable() {
    _classCallCheck(this, ResolutionTable);

    return _possibleConstructorReturn(this, (ResolutionTable.__proto__ || Object.getPrototypeOf(ResolutionTable)).apply(this, arguments));
  }

  _createClass(ResolutionTable, [{
    key: 'renderImageSize',
    value: function renderImageSize() {
      var size = this.props.fileSize;
      if (!this.props.valid) {
        return _react2.default.createElement(
          'div',
          { id: 'wv-image-size', className: 'wv-image-size wv-image-size-invalid grid-child' },
          _react2.default.createElement('i', { className: 'fa fa-times fa-fw' }),
          _react2.default.createElement(
            'span',
            null,
            '~' + size + 'MB'
          )
        );
      } else {
        return _react2.default.createElement(
          'div',
          { id: 'wv-image-size', className: 'wv-image-size grid-child' },
          _react2.default.createElement(
            'span',
            null,
            '~' + size + ' MB',
            ' '
          )
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var imageSize = this.renderImageSize();
      return _react2.default.createElement(
        'div',
        { className: 'wv-image-download-grid' },
        _react2.default.createElement(
          'div',
          { className: 'grid-child grid-head' },
          _react2.default.createElement(
            'span',
            null,
            'Raw Size'
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child grid-head' },
          _react2.default.createElement(
            'span',
            null,
            'Maximum'
          )
        ),
        imageSize,
        _react2.default.createElement(
          'div',
          { className: this.props.valid ? 'grid-child wv-image-max-size' : 'grid-child wv-image-max-size wv-image-size-invalid' },
          _react2.default.createElement(
            'span',
            null,
            this.props.maxImageSize
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child wv-image-dimensions', id: 'wv-image-dimensions' },
          _react2.default.createElement(
            'span',
            null,
            this.props.width + ' x ' + this.props.height + 'px'
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'grid-child wv-image-button' },
          _react2.default.createElement(_button2.default, {
            className: 'black',
            text: 'Download',
            onClick: this.props.onClick,
            valid: this.props.valid
          })
        )
      );
    }
  }]);

  return ResolutionTable;
}(_react2.default.Component);

exports.default = ResolutionTable;

ResolutionTable.propTypes = {
  height: _propTypes2.default.number,
  width: _propTypes2.default.number,
  valid: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  fileSize: _propTypes2.default.string,
  maxImageSize: _propTypes2.default.string
};