'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _selector = require('../util/selector');

var _selector2 = _interopRequireDefault(_selector);

var _grid = require('./grid');

var _grid2 = _interopRequireDefault(_grid);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * A react component, Builds a rather specific
 * interactive widget
 *
 * @class resolutionSelection
 * @extends React.Component
 */
var ImageResSelection = function (_React$Component) {
  _inherits(ImageResSelection, _React$Component);

  function ImageResSelection(props) {
    _classCallCheck(this, ImageResSelection);

    var _this = _possibleConstructorReturn(this, (ImageResSelection.__proto__ || Object.getPrototypeOf(ImageResSelection)).call(this, props));

    _this.state = {
      imageSize: props.imageSize,
      imgHeight: props.imgHeight,
      imgWidth: props.imgWidth,
      resolutions: props.resolutions,
      onSelectionChange: props.onSelectionChange,
      fileType: props.fileType,
      fileTypes: props.fileTypes,
      fileSize: props.fileSize,
      proj: _this.props.proj,
      worldfile: props.worldfile,
      resolution: props.resolution,
      valid: props.valid
    };
    return _this;
  }

  _createClass(ImageResSelection, [{
    key: 'handleChange',
    value: function handleChange(type, value) {
      var fileType = this.state.fileType;
      var resolution = this.state.resolution;
      var worldfile = this.state.worldfile;

      if (type === 'resolution') {
        resolution = value;
      } else if (type === 'worldfile') {
        worldfile = value;
      } else {
        fileType = value;
      }
      this.state = {
        resolution: resolution,
        fileType: fileType,
        worldfile: worldfile
      };
      this.props.onSelectionChange(resolution, worldfile, fileType);
    }
  }, {
    key: '_renderFileTypeSelect',
    value: function _renderFileTypeSelect() {
      if (this.props.fileTypeOptions) {
        return _react2.default.createElement(
          'div',
          { className: 'wv-image-header' },
          _react2.default.createElement(_selector2.default, {
            id: 'wv-image-format',
            optionName: 'filetype',
            value: this.state.fileType,
            optionArray: this.state.fileTypes,
            onChange: this.handleChange.bind(this)
          }),
          this.props.secondLabel
        );
      }
    }
  }, {
    key: '_renderWorldfileSelect',
    value: function _renderWorldfileSelect() {
      var _this2 = this;

      if (this.props.worldFileOptions) {
        return _react2.default.createElement(
          'div',
          { className: 'wv-image-header' },
          _react2.default.createElement(
            'select',
            {
              id: 'wv-image-worldfile',
              value: this.state.worldfile,
              onChange: function onChange(e) {
                return _this2.handleChange('worldfile', e.target.value);
              } },
            _react2.default.createElement(
              'option',
              { value: 'false' },
              'No'
            ),
            _react2.default.createElement(
              'option',
              { value: 'true' },
              'Yes'
            )
          ),
          'Worldfile (.zip)'
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var filetypeSelect = this._renderFileTypeSelect();
      var worldfileSelect = this._renderWorldfileSelect();

      return _react2.default.createElement(
        'div',
        { className: 'wv-re-pick-wrapper' },
        _react2.default.createElement(
          'div',
          { className: 'wv-image-header' },
          _react2.default.createElement(_selector2.default, {
            id: 'wv-image-resolution',
            optionArray: this.state.resolutions,
            value: this.state.resolution,
            optionName: 'resolution',
            onChange: this.handleChange.bind(this)
          }),
          this.props.firstLabel
        ),
        filetypeSelect,
        worldfileSelect,
        _react2.default.createElement(_grid2.default, {
          width: this.state.imgWidth,
          height: this.state.imgHeight,
          fileSize: this.state.fileSize,
          maxImageSize: this.props.maxImageSize,
          valid: this.state.valid,
          onClick: this.props.onDownloadClick
        })
      );
    }
  }]);

  return ImageResSelection;
}(_react2.default.Component);

exports.default = ImageResSelection;


ImageResSelection.defaultProps = {
  firstLabel: 'Resolution (per pixel)',
  secondLabel: 'Format',
  width: '0',
  height: '0',
  imageSize: '0',
  maxImageSize: '250 MB',
  worldfile: false,
  resolution: '1',
  imgHeight: null,
  imgWidth: null,
  worldFileOptions: true,
  fileTypeOptions: true
};
ImageResSelection.propTypes = {
  imageSize: _propTypes2.default.string,
  imgHeight: _propTypes2.default.number,
  imgWidth: _propTypes2.default.number,
  resolutions: _propTypes2.default.object,
  onSelectionChange: _propTypes2.default.func,
  fileType: _propTypes2.default.string,
  fileTypes: _propTypes2.default.object,
  fileSize: _propTypes2.default.string,
  proj: _propTypes2.default.string,
  worldfile: _propTypes2.default.string,
  resolution: _propTypes2.default.string,
  valid: _propTypes2.default.bool,
  onDownloadClick: _propTypes2.default.func,
  firstLabel: _propTypes2.default.string,
  maxImageSize: _propTypes2.default.string,
  worldFileOptions: _propTypes2.default.bool,
  secondLabel: _propTypes2.default.string,
  fileTypeOptions: _propTypes2.default.bool
};