'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _row = require('./row.js');

var _row2 = _interopRequireDefault(_row);

require('whatwg-fetch');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// fetch() polyfill for IE

/*
 * A scrollable list of layers
 * @class LayerList
 * @extends React.Component
 */
var LayerList = function (_React$Component) {
  _inherits(LayerList, _React$Component);

  function LayerList(props) {
    _classCallCheck(this, LayerList);

    var _this = _possibleConstructorReturn(this, (LayerList.__proto__ || Object.getPrototypeOf(LayerList)).call(this, props));

    _this.state = {
      filteredLayers: props.filteredLayers,
      expandedMetadataLayers: [],
      expandedDateRangesLayers: [],
      activeLayers: props.activeLayers
    };
    return _this;
  }

  /*
   * Toggles expansion of metadata for a layer given that layer's ID and makes
   * an AJAX request for the metadata if it's missing
   *
   * @method toggleMetadataExpansion
   * @param {string} layer - the layer to be toggled
   * @return {void}
   */


  _createClass(LayerList, [{
    key: 'toggleMetadataExpansion',
    value: function toggleMetadataExpansion(layerId) {
      var _this2 = this;

      var _state = this.state,
          filteredLayers = _state.filteredLayers,
          expandedMetadataLayers = _state.expandedMetadataLayers;

      var isMetadataExpanded = expandedMetadataLayers.find(function (id) {
        return id === layerId;
      });
      if (isMetadataExpanded) {
        expandedMetadataLayers = expandedMetadataLayers.filter(function (id) {
          return id !== layerId;
        });
      } else {
        expandedMetadataLayers.push(layerId);
        this.setState({ expandedMetadataLayers: expandedMetadataLayers });
        var layer = filteredLayers.find(function (l) {
          return l.id === layerId;
        });
        if (!layer.metadata) {
          var _window$location = window.location,
              origin = _window$location.origin,
              pathname = _window$location.pathname;

          var errorMessage = '<p>There was an error loading layer metadata.</p>';
          var uri = '' + origin + pathname + 'config/metadata/' + layer.description + '.html';
          fetch(uri).then(function (res) {
            return res.ok ? res.text() : errorMessage;
          }).then(function (body) {
            // Check that we have a metadata html snippet, rather than a fully
            // formed HTML file. Also avoid executing any script or style tags.
            var isMetadataSnippet = !body.match(/<(head|body|html|style|script)[^>]*>/i);
            layer.metadata = isMetadataSnippet ? body : errorMessage;
            _this2.setState({ layers: filteredLayers });
          });
        }
      }
    }

    /*
     * Toggles expansion of date ranges for a layer given that layer's ID
     *
     * @method toggleDateRangesExpansion
     * @param {string} layer - The layer being toggled
     * @return {void}
     */

  }, {
    key: 'toggleDateRangesExpansion',
    value: function toggleDateRangesExpansion(layerId) {
      var expandedDateRangesLayers = this.state.expandedDateRangesLayers;

      var isDateRangesExpanded = expandedDateRangesLayers.find(function (id) {
        return id === layerId;
      });
      if (isDateRangesExpanded) {
        expandedDateRangesLayers = expandedDateRangesLayers.filter(function (id) {
          return id !== layerId;
        });
      } else {
        expandedDateRangesLayers.push(layerId);
        this.setState({ expandedDateRangesLayers: expandedDateRangesLayers });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state2 = this.state,
          filteredLayers = _state2.filteredLayers,
          expandedMetadataLayers = _state2.expandedMetadataLayers,
          expandedDateRangesLayers = _state2.expandedDateRangesLayers,
          activeLayers = _state2.activeLayers;
      var _props = this.props,
          addLayer = _props.addLayer,
          removeLayer = _props.removeLayer;

      return _react2.default.createElement(
        'div',
        { style: {
            height: '100%',
            overflowY: 'scroll',
            msOverflowStyle: 'scrollbar',
            WebkitOverflowScrolling: 'touch'
          } },
        filteredLayers.length < 1 ? _react2.default.createElement(
          'div',
          null,
          'No results.'
        ) : null,
        filteredLayers.map(function (layer) {
          var isEnabled = activeLayers.some(function (l) {
            return l.id === layer.id;
          });
          var isMetadataExpanded = expandedMetadataLayers.includes(layer.id);
          var isDateRangesExpanded = expandedDateRangesLayers.includes(layer.id);
          return _react2.default.createElement(_row2.default, {
            key: layer.id,
            layer: layer,
            isEnabled: isEnabled,
            isMetadataExpanded: isMetadataExpanded,
            isDateRangesExpanded: isDateRangesExpanded,
            onState: addLayer,
            offState: removeLayer,
            toggleMetadataExpansion: function toggleMetadataExpansion(id) {
              return _this3.toggleMetadataExpansion(id);
            },
            toggleDateRangesExpansion: function toggleDateRangesExpansion(id) {
              return _this3.toggleDateRangesExpansion(id);
            }
          });
        })
      );
    }
  }, {
    key: '_setListRef',
    value: function _setListRef(ref) {
      this._layerList = ref;
    }
  }]);

  return LayerList;
}(_react2.default.Component);

LayerList.propTypes = {
  addLayer: _propTypes2.default.func,
  removeLayer: _propTypes2.default.func,
  activeLayers: _propTypes2.default.array,
  filteredLayers: _propTypes2.default.array
};

exports.default = LayerList;