'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _util = require('../util/util.js');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var util = new _util2.default();

/**
 * A single layer search result row
 * @class LayerRow
 * @extends React.Component
 */

var LayerRow = function (_React$Component) {
  _inherits(LayerRow, _React$Component);

  function LayerRow(props) {
    _classCallCheck(this, LayerRow);

    var _this = _possibleConstructorReturn(this, (LayerRow.__proto__ || Object.getPrototypeOf(LayerRow)).call(this, props));

    _this.state = {
      checked: props.isEnabled,
      isMetadataExpanded: props.isMetadataExpanded,
      isDateRangesExpanded: props.isDateRangesExpanded
    };
    return _this;
  }

  /**
   * Toggle layer checked state
   * @method toggleCheck
   * @return {void}
   */


  _createClass(LayerRow, [{
    key: 'toggleCheck',
    value: function toggleCheck() {
      var checked = this.state.checked;
      var _props = this.props,
          onState = _props.onState,
          offState = _props.offState,
          layer = _props.layer;

      if (checked) offState(layer.id);
      if (!checked) onState(layer.id);
      this.setState({ checked: !checked });
    }

    /**
     * Toggle switch for the metadata info button and close arrow
     * @method toggleMetadataButtons
     * @param {e} event
     * @return {void}
     */

  }, {
    key: 'toggleMetadataButtons',
    value: function toggleMetadataButtons(e) {
      e.stopPropagation(); // Prevent layer from being activated
      var _props2 = this.props,
          layer = _props2.layer,
          toggleMetadataExpansion = _props2.toggleMetadataExpansion;

      this.setState({ isMetadataExpanded: !this.state.isMetadataExpanded });
      toggleMetadataExpansion(layer.id);
    }

    /**
     * Toggle switch for the metadata info button and close arrow
     * @method toggleMetadataButtons
     * @param {e} event
     * @return {void}
     */

  }, {
    key: 'toggleDateRanges',
    value: function toggleDateRanges(e) {
      e.stopPropagation(); // Prevent layer from being activated
      var _props3 = this.props,
          layer = _props3.layer,
          toggleDateRangesExpansion = _props3.toggleDateRangesExpansion;

      this.setState({ isDateRangesExpanded: !this.state.isDateRangesExpanded });
      toggleDateRangesExpansion(layer.id);
    }

    /**
     * dateRangeText - Return text with the temporal range based on layer start
     * and end dates
     *
     * @method toggleMetadataButtons
     * @param  {object} layer the layer object
     * @return {string}       Return a string with temporal range information
     */

  }, {
    key: 'dateRangeText',
    value: function dateRangeText(layer) {
      var startDate, startDateId, endDate, endDateId;
      var dateRange = '';
      if (layer.startDate) {
        startDate = util.parseDate(layer.startDate);
        if (layer.period === 'subdaily') {
          startDate = startDate.getDate() + ' ' + util.giveMonth(startDate) + ' ' + startDate.getFullYear() + ' ' + util.pad(startDate.getHours(), 2, '0') + ':' + util.pad(startDate.getMinutes(), 2, '0');
        } else if (layer.period === 'yearly') {
          startDate = startDate.getFullYear();
        } else if (layer.period === 'monthly') {
          startDate = util.giveMonth(startDate) + ' ' + startDate.getFullYear();
        } else {
          startDate = startDate.getDate() + ' ' + util.giveMonth(startDate) + ' ' + startDate.getFullYear();
        }
        if (layer.id) startDateId = layer.id + '-startDate';

        if (layer.endDate) {
          endDate = util.parseDate(layer.endDate);
          if (layer.period === 'subdaily') {
            endDate = endDate.getDate() + ' ' + util.giveMonth(endDate) + ' ' + endDate.getFullYear() + ' ' + util.pad(endDate.getHours(), 2, '0') + ':' + util.pad(endDate.getMinutes(), 2, '0');
          } else if (layer.period === 'yearly') {
            if (layer.dateRanges && layer.dateRanges.slice(-1)[0].dateInterval !== '1') {
              endDate = new Date(endDate.setFullYear(endDate.getFullYear() - 1));
            }
            endDate = endDate.getFullYear();
          } else if (layer.period === 'monthly') {
            if (layer.dateRanges && layer.dateRanges.slice(-1)[0].dateInterval !== '1') {
              endDate = new Date(endDate.setMonth(endDate.getMonth() - 1));
            }
            endDate = util.giveMonth(endDate) + ' ' + endDate.getFullYear();
          } else {
            if (layer.dateRanges && layer.dateRanges.slice(-1)[0].dateInterval !== '1') {
              endDate = new Date(endDate.setTime(endDate.getTime() - 86400000));
            }
            endDate = endDate.getDate() + ' ' + util.giveMonth(endDate) + ' ' + endDate.getFullYear();
          }
        } else {
          endDate = 'Present';
        }
        if (layer.id) endDateId = layer.id + '-endDate';
        dateRange = 'Temporal coverage: <span class="layer-date-start" id=' + startDateId + '>' + startDate + '</span> - <span class="layer-end-date" id=' + endDateId + '>' + endDate + '</span>';
      }

      return dateRange;
    }

    // this function takes an array of date ranges in this format:
    // [{ layer.period, dateRanges.startDate: Date, dateRanges.endDate: Date, dateRanges.dateInterval: Number}]
    // the array is first sorted, and then checked for any overlap

  }, {
    key: 'dateOverlap',
    value: function dateOverlap(period, dateRanges) {
      var sortedRanges = dateRanges.sort(function (previous, current) {
        // get the start date from previous and current
        var previousTime = util.parseDate(previous.startDate);
        previousTime = previousTime.getTime();
        var currentTime = util.parseDate(current.startDate);
        currentTime = currentTime.getTime();

        // if the previous is earlier than the current
        if (previousTime < currentTime) {
          return -1;
        }

        // if the previous time is the same as the current time
        if (previousTime === currentTime) {
          return 0;
        }

        // if the previous time is later than the current time
        return 1;
      });

      var result = sortedRanges.reduce(function (result, current, idx, arr) {
        // get the previous range
        if (idx === 0) {
          return result;
        }
        var previous = arr[idx - 1];

        // check for any overlap
        var previousEnd = util.parseDate(previous.endDate);
        // Add dateInterval
        if (previous.dateInterval > 1 && period === 'daily') {
          previousEnd = new Date(previousEnd.setTime(previousEnd.getTime() + (previous.dateInterval * 86400000 - 86400000)));
        }
        if (period === 'monthly') {
          previousEnd = new Date(previousEnd.setMonth(previousEnd.getMonth() + (previous.dateInterval - 1)));
        } else if (period === 'yearly') {
          previousEnd = new Date(previousEnd.setFullYear(previousEnd.getFullYear() + (previous.dateInterval - 1)));
        }
        previousEnd = previousEnd.getTime();

        var currentStart = util.parseDate(current.startDate);
        currentStart = currentStart.getTime();

        var overlap = previousEnd >= currentStart;
        // store the result
        if (overlap) {
          // yes, there is overlap
          result.overlap = true;
          // store the specific ranges that overlap
          result.ranges.push({
            previous: previous,
            current: current
          });
        }

        return result;
      }, {
        overlap: false,
        ranges: []
      });

      // return the final results
      return result;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.state = {
        checked: nextProps.isEnabled,
        isMetadataExpanded: nextProps.isMetadataExpanded,
        isDateRangesExpanded: nextProps.isDateRangesExpanded
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          checked = _state.checked,
          isMetadataExpanded = _state.isMetadataExpanded,
          isDateRangesExpanded = _state.isDateRangesExpanded;
      var layer = this.props.layer;
      var title = layer.title,
          description = layer.description,
          subtitle = layer.subtitle,
          metadata = layer.metadata;

      var listItems;
      var headerClass = 'layers-all-header has-checkbox';
      if (layer.dateRanges && layer.dateRanges.length > 1) {
        var firstDateRange = true;

        var dateRanges = this.dateOverlap(layer.period, layer.dateRanges);

        if (dateRanges.overlap === false) {
          listItems = layer.dateRanges.slice(0).reverse().map(function (l) {
            var startDate = util.parseDate(l.startDate);
            var endDate = util.parseDate(l.endDate);
            var listItemStartDate = void 0;
            var listItemEndDate = void 0;

            if (layer.period === 'subdaily') {
              listItemStartDate = startDate.getDate() + ' ' + util.giveMonth(startDate) + ' ' + startDate.getFullYear() + ' ' + util.pad(startDate.getHours(), 2, '0') + ':' + util.pad(startDate.getMinutes(), 2, '0');

              listItemEndDate = endDate.getDate() + ' ' + util.giveMonth(endDate) + ' ' + endDate.getDate() + ' ' + util.giveMonth(endDate) + ' ' + endDate.getFullYear() + ' ' + util.pad(endDate.getHours(), 2, '0') + ':' + util.pad(endDate.getMinutes(), 2, '0');

              if (firstDateRange) {
                if (layer.endDate === undefined) {
                  listItemEndDate = 'Present';
                }
                firstDateRange = false;
              }

              return _react2.default.createElement(
                _reactstrap.ListGroupItem,
                { key: l.startDate + ' - ' + l.endDate },
                listItemStartDate + ' - ' + listItemEndDate
              );
            } else if (layer.period === 'yearly') {
              if (l.dateInterval === '1' && l.startDate === l.endDate) {
                listItemStartDate = startDate.getFullYear();

                return _react2.default.createElement(
                  _reactstrap.ListGroupItem,
                  { key: l.startDate },
                  listItemStartDate
                );
              } else {
                listItemStartDate = startDate.getFullYear();
                if (l.dateInterval !== '1') {
                  listItemEndDate = new Date(endDate.setFullYear(endDate.getFullYear() - 1 + l.dateInterval));
                }
                listItemEndDate = endDate.getFullYear();

                if (firstDateRange) {
                  if (layer.endDate === undefined) {
                    listItemEndDate = 'Present';
                  }
                  firstDateRange = false;
                }

                return _react2.default.createElement(
                  _reactstrap.ListGroupItem,
                  { key: l.startDate },
                  listItemStartDate + ' - ' + listItemEndDate
                );
              }
            } else if (layer.period === 'monthly') {
              if (l.dateInterval === '1' && l.startDate === l.endDate) {
                listItemStartDate = util.giveMonth(startDate) + ' ' + startDate.getFullYear();

                return _react2.default.createElement(
                  _reactstrap.ListGroupItem,
                  { key: l.startDate },
                  listItemStartDate
                );
              } else {
                listItemStartDate = util.giveMonth(startDate) + ' ' + startDate.getFullYear();
                if (l.dateInterval !== '1') {
                  listItemEndDate = new Date(endDate.setMonth(endDate.getMonth() - 1 + l.dateInterval));
                }
                listItemEndDate = util.giveMonth(endDate) + ' ' + endDate.getFullYear();

                if (firstDateRange) {
                  if (layer.endDate === undefined) {
                    listItemEndDate = 'Present';
                  }
                  firstDateRange = false;
                }

                return _react2.default.createElement(
                  _reactstrap.ListGroupItem,
                  { key: l.startDate },
                  listItemStartDate + ' - ' + listItemEndDate
                );
              }
            } else if (layer.period) {
              if (l.dateInterval === '1' && l.startDate === l.endDate) {
                var _listItemStartDate = startDate.getDate() + ' ' + util.giveMonth(startDate) + ' ' + startDate.getFullYear();

                return _react2.default.createElement(
                  _reactstrap.ListGroupItem,
                  { key: l.startDate + ' - ' + l.endDate },
                  _listItemStartDate
                );
              } else {
                var _listItemStartDate2 = startDate.getDate() + ' ' + util.giveMonth(startDate) + ' ' + startDate.getFullYear();
                if (l.dateInterval !== '1') {
                  listItemEndDate = new Date(endDate.setTime(endDate.getTime() - 86400000 + l.dateInterval * 86400000));
                }
                listItemEndDate = endDate.getDate() + ' ' + util.giveMonth(endDate) + ' ' + endDate.getFullYear();

                if (firstDateRange) {
                  if (layer.endDate === undefined) {
                    listItemEndDate = 'Present';
                  }
                  firstDateRange = false;
                }

                return _react2.default.createElement(
                  _reactstrap.ListGroupItem,
                  { key: l.startDate + ' - ' + l.endDate },
                  _listItemStartDate2 + ' - ' + listItemEndDate
                );
              }
            }
          });
        }
      }
      if (checked) headerClass += ' checked';

      return _react2.default.createElement(
        'div',
        { className: 'layers-all-layer' },
        _react2.default.createElement(
          'div',
          { className: headerClass, onClick: function onClick() {
              return _this2.toggleCheck();
            } },
          _react2.default.createElement(
            'h3',
            null,
            title,
            description && _react2.default.createElement('span', {
              className: 'fa fa-info-circle',
              onClick: function onClick(e) {
                return _this2.toggleMetadataButtons(e);
              }
            })
          ),
          subtitle && _react2.default.createElement(
            'h5',
            null,
            subtitle
          )
        ),
        isMetadataExpanded && metadata && _react2.default.createElement(
          'div',
          { className: 'source-metadata visible' },
          layer.startDate && _react2.default.createElement(
            'p',
            { className: 'layer-date-range' },
            _react2.default.createElement('span', { dangerouslySetInnerHTML: { __html: this.dateRangeText(layer) } }),
            layer.dateRanges && layer.dateRanges.length > 1 && dateRanges.overlap === false && _react2.default.createElement(
              'a',
              { id: 'layer-date-ranges-button', title: 'View all date ranges', className: 'layer-date-ranges-button', onClick: function onClick(e) {
                  return _this2.toggleDateRanges(e);
                } },
              ' ',
              _react2.default.createElement(
                'sup',
                null,
                '*View Dates'
              )
            )
          ),
          isDateRangesExpanded && _react2.default.createElement(
            'div',
            { className: 'layer-date-wrap' },
            _react2.default.createElement(
              'p',
              null,
              'Date Ranges:'
            ),
            _react2.default.createElement(
              _reactstrap.ListGroup,
              { className: 'layer-date-ranges' },
              listItems
            )
          ),
          _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: metadata } }),
          _react2.default.createElement(
            'div',
            { className: 'metadata-more', onClick: function onClick(e) {
                return _this2.toggleMetadataButtons(e);
              } },
            _react2.default.createElement(
              'span',
              { className: 'ellipsis up' },
              '^'
            )
          )
        )
      );
    }
  }]);

  return LayerRow;
}(_react2.default.Component);

LayerRow.propTypes = {
  layer: _propTypes2.default.object,
  isEnabled: _propTypes2.default.bool,
  isMetadataExpanded: _propTypes2.default.bool,
  isDateRangesExpanded: _propTypes2.default.bool,
  onState: _propTypes2.default.func,
  offState: _propTypes2.default.func,
  toggleMetadataExpansion: _propTypes2.default.func,
  toggleDateRangesExpansion: _propTypes2.default.func
};

exports.default = LayerRow;